--TerrainMap uses the "Compass Tiles" resources to build a world map

-- this is a beta build and has extremely limited functionality

local importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"
tilePath=string.gsub(importPath,"%.","/").."Tiles/"

import "Turbine.UI";
import "Turbine.UI.Lotro";
import (importPath.."Class");
import (importPath.."Table");
import (importPath.."VindarPatch");

displayWidth, displayHeight = Turbine.UI.Display.GetSize();

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end
if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end
function SaveData()
	Settings.Language=language
	Settings.Opacity=mapWindow:GetOpacity()
	Settings.TopPercent=mapWindow:GetTop()/displayHeight*100
	Settings.LeftPercent=mapWindow:GetLeft()/displayWidth*100
	Settings.HeightPercent=mapWindow:GetHeight()/displayHeight*100
	Settings.WidthPercent=mapWindow:GetWidth()/displayWidth*100
	Settings.IconLeftPercent=icon:GetLeft()/displayWidth*100
	Settings.IconTopPercent=icon:GetTop()/displayHeight*100

	PatchDataSave(Turbine.DataScope.Account,"TerrainMapSettings",Settings);
end

function LoadData()
	Settings=PatchDataLoad(Turbine.DataScope.Account, "TerrainMapSettings");
	if Settings==nil then
		Settings={}
	else
		Settings.Opacity=euroNormalize(Settings.Opacity)
		Settings.TopPercent=euroNormalize(Settings.TopPercent)
		Settings.LeftPercent=euroNormalize(Settings.LeftPercent)
		Settings.WidthPercent=euroNormalize(Settings.WidthPercent)
		Settings.HeightPercent=euroNormalize(Settings.HeightPercent)
	end
	if Settings.Language==nil then
		local tmpLanguage=Turbine.Engine:GetLanguage()
		if tmpLanguage==Turbine.Language.German then
			language=3
		elseif tmpLanguage==Turbine.Language.French then
			language=2
		elseif tmpLanguage==Turbine.Language.Russian then
			language=4
		else
			language=1
		end
	else
		language=Settings.Language
	end
	if Settings.LoadMinimized==nil then
		Settings.LoadMinimized=false
	end
	if Settings.ShowIcon==nil then
		Settings.ShowIcon=true
	end
	if Settings.Opacity==nil then
		Settings.Opacity=1
	end
	if Settings.TopPercent==nil then
		Settings.TopPercent=0
	end
	if Settings.LeftPercent==nil then
		Settings.LeftPercent=0
	end
	if Settings.WidthPercent==nil then
		Settings.WidthPercent=100
	end
	if Settings.HeightPercent==nil then
		Settings.HeightPercent=100
	end
end
LoadData();
import (importPath.."DebugWindow");
import (importPath.."Grid");
import (importPath.."Strings");
import (importPath.."DropDownList");
import (importPath.."Icon");
import (importPath.."Options");

mapWindow = Turbine.UI.Window();
mapWindow:SetOpacity(Settings.Opacity)
mapWindow:SetWantsKeyEvents(true);
mapWindow.ZoomLevel=1

mapWindow:SetSize(displayWidth*Settings.WidthPercent/100,displayHeight*Settings.HeightPercent/100);
mapWindow:SetPosition(displayWidth*Settings.LeftPercent/100,displayHeight*Settings.TopPercent/100);
mapWindow:SetBackColor(Turbine.UI.Color(0,0,0));
mapWindow.X=0;
mapWindow.Y=0;
mapWindow.Moving=false

mapWindow.MoveTab=Turbine.UI.Control()
mapWindow.MoveTab:SetParent(mapWindow)
mapWindow.MoveTab:SetSize(20,20)
mapWindow.MoveTab:SetBackground(resourcePath.."Move.jpg")
mapWindow.MoveTab.MouseDown=function(sender,args)
	mapWindow.Moving=true
	mapWindow.MoveX=args.X
	mapWindow.MoveY=args.Y
end
mapWindow.MoveTab.MouseUp=function(sender,args)
	mapWindow.Moving=false
end
mapWindow.MoveTab.MouseMove=function(sender,args)
	if mapWindow.Moving then
		local left=mapWindow:GetLeft()+args.X-mapWindow.MoveX
		local top=mapWindow:GetTop()+args.Y-mapWindow.MoveY
		if left<0 then left=0 end
		if top<0 then top=0 end
		if left>displayWidth-10 then left=displayWidth-10 end
		if top>displayHeight-10 then top=displayHeight-10 end
		mapWindow:SetPosition(left,top)
	end
end

mapWindow.OptionsButton=Turbine.UI.Control()
mapWindow.OptionsButton:SetParent(mapWindow)
mapWindow.OptionsButton:SetSize(20,20)
mapWindow.OptionsButton:SetPosition(30,0)
mapWindow.OptionsButton:SetBackground(resourcePath.."options.tga")
mapWindow.OptionsButton.MouseEnter=function()
	mapWindow.OptionsButton:SetBackground(resourcePath.."options_hover.tga")
end
mapWindow.OptionsButton.MouseLeave=function()
	mapWindow.OptionsButton:SetBackground(resourcePath.."options.tga")
end
mapWindow.OptionsButton.MouseClick=function()
	RefreshOptionValues()
	optionsWindow:SetVisible(true)
end

mapWindow.Region=RadioButtonGroup()
mapWindow.Region:SetParent(mapWindow)
mapWindow.Region:SetSize(200,20)
mapWindow.Region:SetPosition(60,0)
mapWindow.Region.UnselectedIcon=resourcePath.."RB_unselected.tga";
mapWindow.Region.SelectedIcon=resourcePath.."RB_selected.tga";
mapWindow.Region.IconWidth=16;
mapWindow.Region.IconHeight=16;
mapWindow.Region:AddChoice(Resource[language][13]);
mapWindow.Region:AddChoice(Resource[language][14]);
mapWindow.Region:SetRows(1);
mapWindow.Region:SetSelectedChoice(1);
mapWindow.Region.SelectionChanged=function()
	local region=mapWindow.Region:GetSelectedChoice()
	local maxRows=(MaxRow[region]-mapWindow.GridRows+2)*200-1
	local maxCols=(MaxCol[region]-mapWindow.GridCols+2)*200-1
	if mapWindow.vGridScroll:GetValue()>maxRows then
		mapWindow.vGridScroll:SetValue(maxRows)
	end
	if mapWindow.hGridScroll:GetValue()>maxCols then
		mapWindow.hGridScroll:SetValue(maxCols)
	end
	mapWindow.vGridScroll:SetMaximum(maxRows)
	mapWindow.hGridScroll:SetMaximum(maxCols)
	mapWindow.ReloadGrid()
end

mapWindow.NSCap=Turbine.UI.Label()
mapWindow.NSCap:SetParent(mapWindow)
mapWindow.NSCap:SetBackColor(Turbine.UI.Color.Black)
mapWindow.NSCap:SetSize(30,20)
mapWindow.NSCap:SetPosition(280,0)
mapWindow.NSCap:SetText(Resource[language][20]..Resource[language][21]..": ")
mapWindow.NSCap:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);

mapWindow.NS=Turbine.UI.TextBox()
mapWindow.NS:SetParent(mapWindow)
mapWindow.NS:SetBackColor(Turbine.UI.Color.Black)
mapWindow.NS:SetSize(70,20)
mapWindow.NS:SetPosition(310,0)
mapWindow.NS:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
mapWindow.NS:SetText("")

mapWindow.EWCap=Turbine.UI.Label()
mapWindow.EWCap:SetParent(mapWindow)
mapWindow.EWCap:SetBackColor(Turbine.UI.Color.Black)
mapWindow.EWCap:SetSize(30,20)
mapWindow.EWCap:SetPosition(380,0)
mapWindow.EWCap:SetText(Resource[language][22]..Resource[language][23]..": ")
mapWindow.EWCap:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight);

mapWindow.EW=Turbine.UI.TextBox()
mapWindow.EW:SetParent(mapWindow)
mapWindow.EW:SetBackColor(Turbine.UI.Color.Black)
mapWindow.EW:SetSize(70,20)
mapWindow.EW:SetPosition(410,0)
mapWindow.EW:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
mapWindow.EW:SetText("")

mapWindow.Zoom=RadioButtonGroup()
mapWindow.Zoom:SetParent(mapWindow)
mapWindow.Zoom:SetSize(200,20)
mapWindow.Zoom:SetPosition(600,0)
mapWindow.Zoom.UnselectedIcon=resourcePath.."RB_unselected.tga";
mapWindow.Zoom.SelectedIcon=resourcePath.."RB_selected.tga";
mapWindow.Zoom.IconWidth=16;
mapWindow.Zoom.IconHeight=16;
mapWindow.Zoom:AddChoice("X1");
mapWindow.Zoom:AddChoice("X2");
--mapWindow.Zoom:AddChoice("X4");
--mapWindow.Zoom:AddChoice("X8");
mapWindow.Zoom:SetRows(1);
mapWindow.Zoom:SetSelectedChoice(1);
mapWindow.Zoom.SelectionChanged=function()
	mapWindow.ZoomLevel=mapWindow.Zoom:GetSelectedChoice()
	mapWindow.MakeGrid()
	-- we fire the scroll value changed events to resynch the scrollbars with the new grid
	mapWindow.vGridScroll.ValueChanged()
	mapWindow.hGridScroll.ValueChanged()
	mapWindow.ReloadGrid()
end

mapWindow.CenterQS=Turbine.UI.Lotro.Quickslot()
mapWindow.CenterQS:SetParent(mapWindow)
mapWindow.CenterQS:SetSize(26,20)
mapWindow.CenterQS:SetPosition(800,0)
mapWindow.CenterQS:SetAllowDrop(false);

mapWindow.Center=Turbine.UI.Control()
mapWindow.Center:SetParent(mapWindow)
mapWindow.Center:SetSize(26,20)
mapWindow.Center:SetPosition(800,0)
mapWindow.Center:SetBackground(resourcePath.."CenterButton.jpg")
mapWindow.Center:SetMouseVisible(false)

mapWindow.Center.Cmd="/loc"
locale=Turbine.Engine:GetLanguage()
if locale==Turbine.Language.French then
	mapWindow.Center.Cmd="/emp"
elseif locale==Turbine.Language.German then
	mapWindow.Center.Cmd="/pos"
end
mapWindow.CenterQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, mapWindow.Center.Cmd));

mapWindow.CenterQS.DragDrop=function()
	-- reestablish the shortcut if the user accidentally drags it onto itself which wipes it out
	mapWindow.CenterQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, mapWindow.Center.Cmd));
end


mapWindow.Usage=Turbine.UI.Control()
mapWindow.Usage:SetParent(mapWindow)
mapWindow.Usage:SetSize(26,20)
mapWindow.Usage:SetPosition(826,0)
mapWindow.Usage:SetBackground(resourcePath.."UsageButton.jpg")
mapWindow.Usage.MouseClick=function()
	usageWindow.UpdateUsage()
	usageWindow:SetVisible(true)
end

mapWindow.CloseButton=Turbine.UI.Control()
mapWindow.CloseButton:SetParent(mapWindow)
mapWindow.CloseButton:SetSize(16,16)
mapWindow.CloseButton:SetPosition(mapWindow:GetWidth()-17,1)
mapWindow.CloseButton:SetBackground(0x41000196)
mapWindow.CloseButton.MouseClick=function()
	mapWindow:SetVisible(false)
	icon:SetVisible(true)
end
mapWindow.CloseButton.MouseEnter=function()
	mapWindow.CloseButton:SetBackground(0x41000198)
end
mapWindow.CloseButton.MouseLeave=function()
	mapWindow.CloseButton:SetBackground(0x41000196)
end

-- we need to create a grid of 200x200 controls that get backgrounds assigned from the list of tiles

mapWindow.mapGrid=Turbine.UI.Control();
mapWindow.mapGrid:SetParent(mapWindow);
mapWindow.mapGrid:SetSize(mapWindow:GetWidth()-10,mapWindow:GetHeight()-20);
mapWindow.mapGrid:SetPosition(0,20);
mapWindow.mapGrid:SetBackColor(Turbine.UI.Color(0,0,0));

mapWindow.GridRows=math.floor(displayHeight/200)+2
mapWindow.GridCols=math.floor(displayWidth/200)+2

Grid[1].NSOffSet=26
Grid[1].EWOffSet=-110.875
Grid[2].NSOffSet=1.25
Grid[2].EWOffSet=-119.75

Grid[1].YOffSet=37400
Grid[1].XOffSet=9200
Grid[2].YOffSet=31200
Grid[2].XOffSet=7000

mapWindow.GridCells={};
mapWindow.GridSelectedResource=""
mapWindow.MakeGrid=function()
	-- remove prior grid, especially event handlers,if any
	for row,rowData in ipairs(mapWindow.GridCells) do
		for col,colData in ipairs(rowData) do
			mapWindow.GridCells[row][col].MouseEnter=nil
			mapWindow.GridCells[row][col].MouseLeave=nil
			mapWindow.GridCells[row][col].MouseUp=nil
			mapWindow.GridCells[row][col].MouseDown=nil
			mapWindow.GridCells[row][col].MouseClick=nil
			mapWindow.GridCells[row][col].MouseMove=nil
			mapWindow.GridCells[row][col].ResourceID=nil
			mapWindow.GridCells[row][col].SelectedOverlay=nil
			mapWindow.GridCells[row][col]=nil
		end
		mapWindow.GridCells[row]=nil		
	end
	-- create new grid
	mapWindow.mapGrid:SetStretchMode(0)
	local zoomMult=1
	if mapWindow.ZoomLevel/2==math.floor(mapWindow.ZoomLevel/2) then zoomMult=2 end

	mapWindow.mapGrid:SetSize((mapWindow:GetWidth()-10)*zoomMult,(mapWindow:GetHeight()-30)*zoomMult);

	for row=1,mapWindow.GridRows*zoomMult do
		mapWindow.GridCells[row]={}
		for col=1,mapWindow.GridCols*zoomMult do
			mapWindow.GridCells[row][col]=Turbine.UI.Label()
			mapWindow.GridCells[row][col]:SetParent(mapWindow.mapGrid)
			mapWindow.GridCells[row][col]:SetSize(200,200)
			mapWindow.GridCells[row][col]:SetPosition((col-1)*200,(row-1)*200)
			mapWindow.GridCells[row][col].Row=row
			mapWindow.GridCells[row][col].Col=col

			mapWindow.GridCells[row][col].MouseDown=function(sender,args)
				mapWindow.Panning=true
				mapWindow.PanX,mapWindow.PanY=Turbine.UI.Display:GetMousePosition()
				mapWindow.ScrollStartX=mapWindow.hGridScroll:GetValue()
				mapWindow.ScrollStartY=mapWindow.vGridScroll:GetValue()
			end
			mapWindow.GridCells[row][col].MouseUp=function(sender,args)
				mapWindow.Panning=false
			end
			mapWindow.GridCells[row][col].MouseMove=function(sender,args)
				if mapWindow.Panning then
					local panX,panY=Turbine.UI.Display:GetMousePosition()
					mapWindow.hGridScroll:SetValue(mapWindow.ScrollStartX+(mapWindow.PanX-panX)*mapWindow.ZoomLevel)
					mapWindow.vGridScroll:SetValue(mapWindow.ScrollStartY+(mapWindow.PanY-panY)*mapWindow.ZoomLevel)
				else
					local X=(mapWindow.X+sender.Col-1)*.8+args.X/200
					local Y=(mapWindow.Y+sender.Row-1)*.8+args.Y/200
					local region=mapWindow.Region:GetSelectedChoice()
					local NS=math.floor((Grid[region].NSOffSet-Y)*100)/100
					local EW=math.floor((Grid[region].EWOffSet+X)*100)/100
					if NS<0 then
						mapWindow.NS:SetText(tostring(0-NS).." "..Resource[language][21])
					else
						mapWindow.NS:SetText(tostring(NS).." "..Resource[language][20])
					end
					if EW<0 then
						mapWindow.EW:SetText(tostring(0-EW).." "..Resource[language][23])
					else
						mapWindow.EW:SetText(tostring(EW).." "..Resource[language][22])
					end
				end
			end
		end
	end
	if zoomMult==2 then
		mapWindow.mapGrid:SetStretchMode(1)
	end
	mapWindow.mapGrid:SetSize(mapWindow:GetWidth()-10,mapWindow:GetHeight()-30);
end
mapWindow.MakeGrid()
mapWindow.ReloadGrid=function()
	local region=mapWindow.Region:GetSelectedChoice()
	local x=math.floor(mapWindow.hGridScroll:GetValue()/200)
	local y=math.floor(mapWindow.vGridScroll:GetValue()/200)
	local zoom=1
	if x==nil then x=0 end
	if y==nil then y=0 end
	if mapWindow.ZoomLevel>2 then
		zoom=4
		x=math.floor(x/zoom)*zoom
		y=math.floor(y/zoom)*zoom
	end
	for row,rowCells in ipairs(mapWindow.GridCells) do
		for col,Cell in ipairs(rowCells) do
			local tmpRegion=Grid[region]
			local tmpCell
			local row2=(row-1)*zoom+y+1
			local col2=(col-1)*zoom+x+1

			if tmpRegion~=nil then
				local tmpRow=tmpRegion[row2]
				if tmpRow~=nil then
					local tmpCol=tmpRow[col2]
					if tmpCol~=nil then
						tmpCell=tmpCol[zoom]
					end
				end
			end
			if tmpCell==nil then
				Cell:SetBackColor(Turbine.UI.Color(.2,.2,.2))
				Cell.ResourceID=nil
			else
				Cell.ResourceID=tmpCell
				Cell:SetBackColor(nil)
			end
			if type(tmpCell)=="string" then
				success,result=pcall(Turbine.UI.Control.SetBackground,Cell,tilePath..tmpCell)
			else
				Cell:SetBackground(tmpCell)
			end
		end
	end
end

-- main control needs scroll bars
mapWindow.vGridScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.vGridScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.vGridScroll:SetParent(mapWindow);
mapWindow.vGridScroll:SetBackColor(Turbine.UI.Color(0,0,0));
mapWindow.vGridScroll:SetWidth(10);
mapWindow.vGridScroll:SetHeight(mapWindow.mapGrid:GetHeight());
mapWindow.vGridScroll:SetPosition(mapWindow.mapGrid:GetLeft()+mapWindow.mapGrid:GetWidth(),mapWindow.mapGrid:GetTop());
mapWindow.vGridScroll:SetZOrder(3);
mapWindow.vGridScroll:SetMinimum(0)
-- -mapWindow.GridRows+1
mapWindow.vGridScroll:SetMaximum((MaxRow[1]-mapWindow.GridRows+2)*200-1)

mapWindow.vGridScroll:SetValue(0)
mapWindow.vGridScroll:SetVisible(true);
mapWindow.vGridScroll.ValueChanged=function(sender,args)
	local yValue=mapWindow.vGridScroll:GetValue();
	local y=math.floor(yValue/200)
	local yOffset=yValue-y*200

	-- now move all of the grid elements to the yOffset
	for row,rowCells in ipairs(mapWindow.GridCells) do
		for col,Cell in ipairs(rowCells) do
			Cell:SetTop((row-1)*200-yOffset)
		end
	end
	y2=tonumber(mapWindow.Y)
	if (y+1)~=y2 then
		mapWindow.Y=y+1
		-- reload the grid images since we have a new start coordinate
		mapWindow.ReloadGrid()
	end
end

mapWindow.hGridScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.hGridScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
mapWindow.hGridScroll:SetParent(mapWindow);
mapWindow.hGridScroll:SetBackColor(Turbine.UI.Color(0,0,0));
mapWindow.hGridScroll:SetHeight(10);
mapWindow.hGridScroll:SetWidth(mapWindow.mapGrid:GetWidth());
mapWindow.hGridScroll:SetPosition(mapWindow.mapGrid:GetLeft(),mapWindow.mapGrid:GetTop()+mapWindow.mapGrid:GetHeight());
mapWindow.hGridScroll:SetMinimum(0)
mapWindow.hGridScroll:SetMaximum((MaxCol[1]-mapWindow.GridCols+2)*200-1)

mapWindow.hGridScroll:SetValue(0)
mapWindow.hGridScroll:SetZOrder(3);
mapWindow.hGridScroll:SetVisible(true);
mapWindow.hGridScroll.ValueChanged=function(sender,args)
	local xValue=mapWindow.hGridScroll:GetValue();
	local x=math.floor(xValue/200)
	local xOffset=xValue-x*200

	-- now move all of the grid elements to the xOffset
	for row,rowCells in ipairs(mapWindow.GridCells) do
		for col,Cell in ipairs(rowCells) do
			Cell:SetLeft((col-1)*200-xOffset)
		end
	end
	x2=tonumber(mapWindow.X)
	if (x+1)~=x2 then
		mapWindow.X=x+1
		-- reload the grid images since we have a new start coordinate
		mapWindow.ReloadGrid()
	end
end

mapWindow.SizeTab=Turbine.UI.Control()
mapWindow.SizeTab:SetParent(mapWindow)
mapWindow.SizeTab:SetSize(10,10)
mapWindow.SizeTab:SetPosition(mapWindow:GetWidth()-10,mapWindow:GetHeight()-10)
mapWindow.SizeTab:SetBackground(resourcePath.."Resize.jpg")
mapWindow.SizeTab.MouseDown=function(sender,args)
	mapWindow.Sizing=true
	mapWindow.MoveX=args.X
	mapWindow.MoveY=args.Y
end
mapWindow.SizeTab.MouseUp=function(sender,args)
	mapWindow.Sizing=false
	if mapWindow.ZoomLevel>1 then
		-- need to recreate the grid since we just stretched it :(
		mapWindow.MakeGrid()
		mapWindow.vGridScroll.ValueChanged()
		mapWindow.hGridScroll.ValueChanged()
		mapWindow.ReloadGrid()
	end
end
mapWindow.SizeTab.MouseMove=function(sender,args)
	if mapWindow.Sizing then
		local width=mapWindow:GetWidth()+args.X-mapWindow.MoveX
		local height=mapWindow:GetHeight()+args.Y-mapWindow.MoveY
		if width<30 then width=30 end
		if height<30 then height=30 end
		if width>displayWidth then width=displayWidth end
		if height>displayHeight then height=displayHeight end
		mapWindow:SetSize(width,height)
	end
end

hudVisible=true; -- terrible assumption but we have no choice
mapVisible=false;
usageVisible=false;
iconVisible=false;
optionsVisible=false;
mapWindow.KeyDown=function(sender, args)
--Turbine.Shell.WriteLine("KeyDown Action="..args.Action..", .Alt="..tostring(args.Alt)..", .Control="..tostring(args.Control)..", .Shift="..tostring(args.Shift))
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		mapWindow:SetVisible(false)
		usageWindow:SetVisible(false)
		optionsWindow:SetVisible(false)
		if Settings.ShowIcon then
			icon:SetVisible(true)
		end
	elseif ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			mapWindow:SetVisible(mapVisible);
			usageWindow:SetVisible(usageVisible);
			icon:SetVisible(iconVisible);
			optionsWindow:SetVisible(optionsVisible);
		else
			usageVisible=usageWindow:IsVisible();
			usageWindow:SetVisible(false);
			mapVisible=mapWindow:IsVisible();
			mapWindow:SetVisible(false);
			iconVisible=icon:IsVisible();
			icon:SetVisible(false);
			optionsVisible=optionsWindow:IsVisible();
			optionsWindow:SetVisible(false);
		end
	end
end

plugin.Unload=function()
	Turbine.Shell.RemoveCommand(mapWindow.shellCmd)
	if mapWindow~=nil and mapWindow.chatListener~=nil then
		RemoveCallback(Turbine.Chat, "Received", mapWindow.chatListener);
	end
	SaveData();
	-- remove shell commands
	Turbine.Shell.WriteLine("TerrainMap "..Plugins["TerrainMap"]:GetVersion().." by Garan unloaded");
end

mapWindow.chatListener=function(sender, args)
	-- check message for standard channel matching "You are at: r.* lx.* ly.* ox.* oy.* oz.* h.*"
	local locationString,headingString,patternString1,patternString2,patternString3,patternString4;
	locale=Turbine.Engine:GetLanguage()
	if locale==Turbine.Language.French then
		locationString="Votre emplacement .*: r.*"
		headingString="Votre emplacement .*: r.* h.*"
		patternString1="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	elseif locale==Turbine.Language.German then
		locationString="Ihr befindet Euch hier: r.*"
		headingString="Ihr befindet Euch hier: r.* h.*"
		patternString1="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	else
		-- russian is not currently supported by this plugin
		locationString="You are at: r.*"
		headingString="You are at: r.* h.*"
		patternString1="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	end
	if args.ChatType==Turbine.ChatType.Standard and string.find(args.Message,locationString)~=nil then
		local region, lx, ly, ox, oy, oz, heading;
		if string.find(args.Message,headingString)==nil then
			-- there is a carriage return at the end of the message :(
			heading=0;
			region, lx, ly, ox, oy, oz = string.match(args.Message,patternString1);
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2);
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3);
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4);
					end
				end
			end
		else
			region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString1.." h(%d+%.?%d*)");
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2.." h(%d+%.?%d*)");
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3.." h(%d+%.?%d*)");
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4.." h(%d+%.?%d*).*");
					end
				end
			end
		end
		if region ~= nil then
			if heading ==nil then
				-- when facing north the heading value is not present
				heading=0
			end
			region=tonumber(region);
			ox=euroNormalize(ox);
			oy=euroNormalize(oy);
			oz=euroNormalize(oz);
			heading=euroNormalize(heading);
			mapWindow.Region:SetSelectedChoice(region)
-- these have to change with zoomlevel>2  for 1 and 2 this formula is ok
			local xoffset=(mapWindow:GetWidth()/2-5)*mapWindow.ZoomLevel
			local yoffset=(mapWindow:GetHeight()/2-5)*mapWindow.ZoomLevel
				local h,v=(( math.floor( lx / 8 ) * 160 + ox ))*1.25-Grid[region].XOffSet-xoffset,Grid[region].YOffSet-(( math.floor( ly / 8 ) * 160 + oy ))*1.25-yoffset;
			if v<0 then
				v=0
			end
			if h<0 then
				h=0
			end
			mapWindow.vGridScroll:SetValue(v)
			mapWindow.hGridScroll:SetValue(h)
		end
	end
end

AddCallback(Turbine.Chat, "Received", mapWindow.chatListener);
mapWindow.shellCmd=Turbine.ShellCommand();
Turbine.Shell.AddCommand("TerrainMap",mapWindow.shellCmd);

mapWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == "terrainmap") then
		local pos1=string.find(args," ",0,true);
		local command;
		args=string.lower(args)
		if pos1~=nil and pos1>0 then
			command=string.sub(args,1,pos1-1);
		else
			command=args;
		end
		if (command=="show") then
			mapWindow:SetVisible(true);
		elseif (args=="debug on") then
			if debugWindow==nil then
				debugWindow=DebugWindow()
			end
			debugWindow:SetVisible(true);
		elseif (args=="debug off") then
			if debugWindow~=nil then
				debugWindow:SetVisible(false);
			end
		elseif (args=="usage") then
			usageWindow.UpdateUsage()
			usageWindow:SetVisible(true)
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /MapMaker show");
			Turbine.Shell.WriteLine("       Displays the MapMaker window.");
			Turbine.Shell.WriteLine("  /MapMaker debug on|off");
			Turbine.Shell.WriteLine("       Shows or Hides the Debug window.");
		end
	end
end
mapWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /MapMaker show\n       Displays the MapMaker window.");
end
mapWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return("MapMaker - usage: /MapMaker show");
end
mapWindow.SizeChanged=function()
	local newWidth,newHeight=mapWindow:GetSize()
	mapWindow.mapGrid:SetSize(newWidth-10,newHeight-30);
--	if mapWindow.ZoomLevel>1 then
--		-- need to recreate the grid since we just stretched it :(
--		mapWindow.MakeGrid()
--		mapWindow.vGridScroll.ValueChanged()
--		mapWindow.hGridScroll.ValueChanged()
--		mapWindow.ReloadGrid()
--	end
	mapWindow.hGridScroll:SetWidth(newWidth-10);
	mapWindow.hGridScroll:SetTop(newHeight-10);
	mapWindow.vGridScroll:SetHeight(newHeight-30);
	mapWindow.vGridScroll:SetLeft(newWidth-10);
	mapWindow.SizeTab:SetPosition(newWidth-10,newHeight-10)
	mapWindow.CloseButton:SetLeft(newWidth-17)
end

mapWindow:ReloadGrid()
if not Settings.LoadMinimized then
	mapWindow:SetVisible(true);
end
mapWindow:SetZOrder(2);
optionsWindow:SetZOrder(3);

usageWindow=Turbine.UI.Window()
usageWindow:SetSize(displayWidth,displayHeight)
usageWindow:SetVisible(false)
usageWindow:SetBackColor(Turbine.UI.Color.Black)
usageWindow:SetZOrder(3)
usageWindow.CloseButton=Turbine.UI.Control()
usageWindow.CloseButton:SetParent(usageWindow)
usageWindow.CloseButton:SetSize(16,16)
usageWindow.CloseButton:SetPosition(usageWindow:GetWidth()-16,0)
usageWindow.CloseButton:SetBackground(0x41000196)
usageWindow.CloseButton.MouseClick=function()
	usageWindow:SetVisible(false)
end
usageWindow.CloseButton.MouseEnter=function()
	usageWindow.CloseButton:SetBackground(0x41000198)
end
usageWindow.CloseButton.MouseLeave=function()
	usageWindow.CloseButton:SetBackground(0x41000196)
end
usageWindow.Display=Turbine.UI.ListBox()
usageWindow.Display:SetParent(usageWindow)
usageWindow.Display:SetSize(displayWidth-16,displayHeight-26)
usageWindow.Display:SetBackColor(Turbine.UI.Color.Green)
usageWindow.Display:SetPosition(0,16)

usageWindow.UpdateUsage=function()
	local region=mapWindow.Region:GetSelectedChoice()
	usageWindow.Display:ClearItems()
	for tmpIndex=1,MaxRow[region] do
		local tmpRow=Turbine.UI.Label()
		tmpRow:SetBackColor(Turbine.UI.Color.Blue)
		tmpRow:SetParent(usageWindow.Display)
		tmpRow:SetSize(MaxCol[region]*7+15,7)
		tmpRow.Row=tmpIndex
		tmpRow.MouseClick=function(sender,args)
			local row=sender.Row-1
			local col=math.floor(args.X/7)
			mapWindow.hGridScroll:SetValue(col*200)
			mapWindow.hGridScroll.ValueChanged()
			mapWindow.vGridScroll:SetValue(row*200)
			mapWindow.vGridScroll.ValueChanged()
			usageWindow:SetVisible(false)
		end
		usageWindow.Display:AddItem(tmpRow)
	end
-- create the strings based on existance of an image at each row/col
	for row=1,MaxRow[region] do
		local lbl=usageWindow.Display:GetItem(row)
		local tmpStr=""
		for col=1,MaxCol[region] do
			local gridRegion=Grid[region]
			local char="\194\183"
			if gridRegion~=nil then
				local gridRow=gridRegion[row]
				if gridRow~=nil then
					local gridCol=gridRow[col]
					if gridCol~=nil and gridCol[1]~=nil then
						char="\194\164"
					end
				end
			end
			tmpStr=tmpStr..char
		end
		lbl:SetText(tmpStr)
	end
end

usageWindow.vScroll=Turbine.UI.Lotro.ScrollBar();
usageWindow.vScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
usageWindow.vScroll:SetParent(usageWindow);
usageWindow.vScroll:SetBackColor(Turbine.UI.Color(0,0,0));
usageWindow.vScroll:SetWidth(10);
usageWindow.vScroll:SetHeight(usageWindow.Display:GetHeight());
usageWindow.vScroll:SetPosition(usageWindow.Display:GetLeft()+usageWindow.Display:GetWidth(),usageWindow.Display:GetTop());
usageWindow.Display:SetVerticalScrollBar(usageWindow.vScroll)

usageWindow.hScroll=Turbine.UI.Lotro.ScrollBar();
usageWindow.hScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
usageWindow.hScroll:SetParent(usageWindow);
usageWindow.hScroll:SetBackColor(Turbine.UI.Color(0,0,0));
usageWindow.hScroll:SetHeight(10);
usageWindow.hScroll:SetWidth(usageWindow.Display:GetWidth());
usageWindow.hScroll:SetPosition(usageWindow.Display:GetLeft(),displayHeight-10);
usageWindow.Display:SetHorizontalScrollBar(usageWindow.hScroll)
